﻿' John Doe
' TicTacToe2Player
' Period ?

Public Class Form1

    Dim mPlayerTurn As String = "X"             ' keeps track of whose turn it is, X or O
    Const PASSCODE As String = "chess"            ' passcode for user to play the game

    ' player makes move
    Private Sub MakeMove(ByVal clickedButton As Button)

        If (clickedButton.Text <> "") Then      ' cheat detection, cannot take an occupied square
            MessageBox.Show("Illegal Move")
        ElseIf (mPlayerTurn = "X") Then
            clickedButton.Text = "X"            ' mark the clicked button with an "X"
            mPlayerTurn = "O"
        ElseIf (mPlayerTurn = "O") Then          ' mark the clicked button with an "O"
            clickedButton.Text = "O"
            mPlayerTurn = "X"
        End If

        WinDetection()                          ' check to see if game is over

        lblPlayerTurn.Text = mPlayerTurn         ' change player turn
    End Sub

    ' player moves to row 1 column 1
    Private Sub btn11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn11.Click
        MakeMove(btn11)
    End Sub

    ' player moves to row 1 column 2
    Private Sub btn12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn12.Click
        MakeMove(btn12)
    End Sub

    ' player moves to row 1 column 3
    Private Sub btn13_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn13.Click
        MakeMove(btn13)
    End Sub

    ' player moves to row 2 column 1
    Private Sub btn21_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn21.Click
        MakeMove(btn21)
    End Sub

    ' player moves to row 2 column 2
    Private Sub btn22_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn22.Click
        MakeMove(btn22)
    End Sub

    ' player moves to row 2 column 3
    Private Sub btn23_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn23.Click
        MakeMove(btn23)
    End Sub

    ' player moves to row 3 column 1
    Private Sub btn31_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn31.Click
        MakeMove(btn31)
    End Sub

    ' player moves to row 3 column 2
    Private Sub btn32_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn32.Click
        MakeMove(btn32)
    End Sub

    ' player moves to row 3 column 3
    Private Sub btn33_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn33.Click
        MakeMove(btn33)
    End Sub

    ' **********************************************************************
    '            DO NOT MAKE ANY CHANGES TO THE CODE ABOVE THIS AREA
    '            WITHOUT FIRST TALKING TO MR. MINICH 
    ' **********************************************************************

    ' detects if X or O wins or if there is a draw
    Private Sub WinDetection()

        If (btn11.Text = "X" And btn12.Text = "X" And btn13.Text = "X") Then        ' X wins - top row
            MessageBox.Show("X wins")
            GameReset()
        ElseIf (btn11.Text = "O" And btn12.Text = "O" And btn13.Text = "O") Then    ' O wins - top row
            MessageBox.Show("O wins")
            GameReset()

            ' add more ElseIf clauses here to detect all X and O wins and a draw

        End If

    End Sub

    ' resets game board for a new game
    Private Sub GameReset()
        btn11.Text = ""         ' set all button Text properties to empty strings
        btn12.Text = ""
        btn13.Text = ""
    End Sub

    ' recommends a move to the player
    Private Sub btnHint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHint.Click

        If (btn13.Text = "" And (btn11.Text = "X" And btn12.Text = "X" Or btn11.Text = "O" And btn12.Text = "O")) Then
            MessageBox.Show("I recommend that " + mPlayerTurn + " goes in position Row 1 Column 3 to block or win")
        ElseIf (btn12.Text = "" And (btn11.Text = "X" And btn13.Text = "X" Or btn11.Text = "O" And btn13.Text = "O")) Then
            MessageBox.Show("I recommend that " + mPlayerTurn + " goes in position Row 1 Column 2 to block or win")

            ' add more ElseIf clauses here to recommend as many X and O blocks and wins as you can

        End If

    End Sub

    ' check for correct passcode
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        If (InputBox("Enter the passcode: ") <> PASSCODE) Then
            MessageBox.Show("Sorry, you failed to type the correct passcode.")
            Application.Exit()
        End If

    End Sub

End Class
